/*
 *  Project: Stop Verbosity
 *  Description: Limits and counts the characters in a textarea.
 *  Author: William Huey
 *  License: MIT
 *  Version: 1.14.2
 *
 *  Credits:
 *  Tim Down (getInputSelection, setInputSelection)
 *    http://stackoverflow.com/questions/3549250/highlighting-a-piece-of-string-in-a-textarea
 *  Ben Alpert(isInputSupported)
 *    http://benalpert.com/2013/06/18/a-near-perfect-oninput-shim-for-ie-8-and-9.html
 *  matt (getTextAreaLength regex)
 *    http://stackoverflow.com/questions/10030921/chrome-counts-characters-wrong-in-textarea-with-maxlength-attribute
 */
 
!function(t,e,n){"use strict";var o="stopVerbosity",a=function(e,a){var r={limit:10,limitFromTextArea:!1,indicatorPosition:"after",indicatorId:"",indicatorElementType:"p",indicatorPhrase:["Used","[countup]","of","[limit]","characters.","[countdown]","characters remaining.","The maximum is","[limit]","characters.","<br>","Permits multiple counts up:","[countup]","and counts down:","[countdown].","This indicator is customizable."],indicatorUpdateSpeed:0,existingIndicator:"",generateIndicator:!0,showIndicator:!0,useNativeMaxlength:!0,textLengthChange:!1,useMaxlength:!0,beforeAttachment:null,afterAttachment:null,existingText:"clear"},i=function(e,n){i.element=e,i.options=t.extend({},r,n)},c=i.prototype={init:function(){var n=t(e),o=c.setupActions().init(n,i.options);c.eventsActions(n).init(i.options.limit,o)},setupActions:function(){var t=function(){};return t.prototype={init:function(e,n){try{"[object Function]"===Object.prototype.toString.call(n.beforeAttachment)&&n.beforeAttachment.call(e)}catch(o){throw new TypeError("beforeAttachment is not a proper function.")}Array.prototype.indexOf||(Array.prototype.indexOf=function(t){if(null==this)throw new TypeError;var e=Object(this),n=e.length>>>0;if(0===n)return-1;var o=0;if(arguments.length>1&&(o=Number(arguments[1]),o!=o?o=0:0!=o&&1/0!=o&&o!=-1/0&&(o=(o>0||-1)*Math.floor(Math.abs(o)))),o>=n)return-1;for(var a=o>=0?o:Math.max(n-Math.abs(o),0);n>a;a++)if(a in e&&e[a]===t)return a;return-1});var a=n.limit,r=n.indicatorPosition,i=n.indicatorId,c=n.indicatorElementType,s=n.indicatorPhrase,u=n.existingIndicator,l=n.generateIndicator,d=n.showIndicator,h=n.useNativeMaxlength,p=n.existingText,f=t.prototype,g=f.setupDataStore;g.useNativeMaxlength=h,g.indicatorUpdateSpeed=n.indicatorUpdateSpeed,g.textLengthChange=n.textLengthChange,g.useMaxlength=n.useMaxlength,g.showIndicator=d,g.afterAttachment=n.afterAttachment,g.existingText=n.existingText,g.limitFromTextArea=n.limitFromTextArea;var v=f.checkExistingTextarea(e);return a=f.checkLimitOption(a,n.limitFromTextArea,v),n.limit!=a&&(n.limit=a),f.setIndicator(a,c,i,r,s,e,u,l,d,p),f.setupDataStore},checkExistingTextarea:function(t){if("[object Object]"===Object.prototype.toString.call(t))try{if(t instanceof jQuery)return t.attr("maxlength")}catch(e){throw new TypeError("Not a jQuery Object.")}},checkLimitOption:function(t,e,n){var t;if(e&&this.setupDataStore.limitFromTextArea&&n){var o=parseInt(n,10);"number"==typeof o&&(t=o)}if("number"!=typeof t)throw new TypeError("Specified text limit is not a number.");if(0>=t||parseFloat(t)!=parseInt(t,10))throw new RangeError("Text limit is not a valid positive integer.");return t},setIndicator:function(t,e,n,o,a,r,i,c,s){function u(e,n,o){for(var a=0,r=e.length;r>a;a++){var i=e[a],c=i.length,s="["+i+"]",u="\\["+i+"\\]",l=i+"Coupled",d=0,h=n.length,p=new RegExp(u);for(l=o.setupDataStore[l]={};h>d;d++){var f=n[d];if(f===s)o.setupDataStore[i].push(d);else if(p.test(f)){var g=f.indexOf(s),v=[];for(v.push(g);g>-1;)g=f.indexOf(s,g+1),g>-1&&v.push(g);if(1===v.length){var S=l[d]={},m=p.exec(f).index,x=f.slice(0,m),y=m+c+2,w=f.length,T=f.slice(y,w);switch(i){case"limit":case"countdown":n[d]=x+t+T;break;case"countup":n[d]=x+"0"+T}var k=w-y;S.firstEnd=m,S.backDifference=k}}}}}function l(t,e,n,o){for(var a=0,r=t.length;r>a;a++)for(var i=t[a],c=o.setupDataStore[i],s=c.length,u=0;s>u;u++){var l=c[u];switch(i){case"countup":n[l]=0;break;default:e.phrase[l]=e.limit}}}if(s){var d=this;u(["limit","countup","countdown"],a,d);var h={phrase:a,limit:t};if(l(["limit","countdown","countup"],h,a,d),"[object Object]"===Object.prototype.toString.call(i))try{i instanceof jQuery&&(this.setupDataStore.indicatorElement=i,i.html(a.join(" ")),c=!1)}catch(p){throw new TypeError("Not a jQuery Object.")}if(this.setupDataStore.indicatorPhrase=a,c){var f=n.length>0?" id="+n:"",g=["<",e,f,">",a.join(" "),"</",e,">"].join(""),v=["Not a valid position for indicator,","only accepts ","'before'"," or ","'after'"].join("");if("after"===o)r.after(g),this.setupDataStore.indicatorElement=r.next();else{if("before"!==o)throw new Error(v);r.before(g),this.setupDataStore.indicatorElement=r.prev()}}}},setupDataStore:{limit:[],countup:[],countdown:[]}},t.prototype},eventsActions:function(e){var a=function(){},r=a.prototype={init:function(t,e){r.addListeners(t,e)},addListeners:function(t,a){var c=this.dataStore;c.limit=t,c.indicator=a;var s=a.indicatorUpdateSpeed,u=a.existingText,l={preventFunction:function(){null!==c.eventPrevent||c.isTextSelected||(r.setDataStore("eventPrevent","keydown"),r.removeDataStore("eventPresent"),e.off("keydown."+o),r.keydownFunction.keydownPrevent(),r.pastePreventFunction())},allowFunction:function(){null!==c.eventPrevent&&(r.removeDataStore("eventPrevent"),r.setDataStore("eventPresent","keydown"),e.off("keydown."+o).off("paste."+o),r.keydownFunction.keydown())},changeText:function(e){for(var n=c.indicator,o=0,a=e.length;a>o;o++){var i=e[o],u=n[i];if("undefined"!=typeof u){var l=Object.prototype.toString.call(u);if("[object Object]"===l){for(var d in u)if(u.hasOwnProperty(d)){var h,p=n.indicatorPhrase[d],f=p.length,g=u[d],v=p.slice(0,g.firstEnd),S=f-g.backDifference,m=g.backDifference+f,x=p.slice(S,m);"countdownCoupled"===i?(y=t-r.getTextAreaLength(),h=v+y+x):"countupCoupled"===i&&(y=r.getTextAreaLength(),h=v+y+x),n.indicatorPhrase[d]=h}}else if("[object Array]"===l){var y;"countdown"===i?y=t-r.getTextAreaLength():"countup"===i&&(y=r.getTextAreaLength());for(var w=n[i],T=w.length,k=0;T>k;k++)n.indicatorPhrase[w[k]]=y}}}s>0?setTimeout(function(){n.indicatorElement.html(n.indicatorPhrase.join(" "))},s):n.indicatorElement.html(n.indicatorPhrase.join(" "))},textLengthChange:function(n){if(a.textLengthChange){var o=r.getTextAreaLength();o!==n&&(d.currentTextLength=o,d.lastTextLength=n,t>o?(d.isLimitReached=!1,d.exceededLimit=!1):o===t?(d.isLimitReached=!0,d.exceededLimit=!1):o>t&&(d.isLimitReached=!0,d.exceededLimit=!0),e.trigger("sv-textLengthChange",d))}}},d=l.textLengthChange.obj={};d.element=i.element,c.indicator.indicatorElement&&(d.indicatorElement=c.indicator.indicatorElement);var h,p=n.createElement("textarea");if("oninput"in p?(c.partialInputSupport=!0,(!("documentMode"in n)||n.documentMode>9)&&(h=!1,c.supportsInput=!0,c.partialInputSupport=!1)):"onpropertychange"in p&&(h=!0,c.supportsInput=!1),c.checkFirstKeyDown=h,"maxLength"in p&&a.useNativeMaxlength&&a.useMaxlength&&e.attr("maxlength",t),r.setInputSelection.offsetToRangeCharacterMove=function(t,e){return e-(t.value.slice(0,e).split("\r\n").length-1)},r.deselectFunction(l),r.selectFunction(l),r.dropFunction(),r.inputFunction(l),r.trackSelectionEventsFunction(),r.mousedownFunction(),r.clickFunction(),r.keydownFunction(),"clear"===u)e.val("");else{if("truncate"!==u)throw new Error('Must be string value of "clear" or "truncate".');e.val().length>0&&e.trigger("propertychange."+o)}try{"[object Function]"===Object.prototype.toString.call(a.afterAttachment)&&a.afterAttachment.call(e,d)}catch(f){throw new TypeError("afterAttachment is not a proper function.")}},inputFunction:function(a){var i=r.dataStore,c=["countdown","countup","countdownCoupled","countupCoupled"],s={},u=function(){i.indicator.showIndicator?(a.changeText(c),r.copyObjectValue(i,s,"lengthText"),r.setDataStore("lengthText",r.getTextAreaLength()),a.textLengthChange(s.lengthText)):r.setDataStore("lengthText",r.getTextAreaLength())};e.on("input."+o+" propertychange."+o,function(){if(i.checkFirstKeyDown=!1,r.dataStore.dropOccurred)return void(r.dataStore.dropOccurred=!1);var t=i.limit,n=r.checkLimit(t);if(r.setDataStore("textStatus",n),"less"===n)i.falsePositive&&a.allowFunction(),u(),setTimeout(function(){r.trackSelectionFunction()});else if("equal"===n)i.falsePositive&&i.indicator.useMaxlength&&a.preventFunction(),u(),setTimeout(function(){if(r.trackSelectionFunction(),i.falsePositive&&"number"==typeof r.dataStore.newCaretPos){var t=r.dataStore.newCaretPos;r.setInputSelection(t,t),r.dataStore.newCaretPos=null}});else if("greater"===n)if(i.falsePositive=!0,i.selectBeforeKeydown&&(i.caretStatus=i.selectCaretStatus),i.indicator.useMaxlength){var c,s,l,d,h=r.getTextAreaLength(),p=i.caretStatus,f=p.start,g=p.end,v=i.lengthText,S=t-v,m=r.getText();i.isTextSelected||i.selectBeforeKeydown?(c=p.end,l=p.end,d=S+g,s=h-(v-g)):(c=f,l=f,d=S+f,s=h-(v-f));var x=m.slice(0,c),y=m.slice(l,d),w=m.slice(s,h),T=x+y+w,k=x.length+y.length;i.newCaretPos=k,T.length<=t&&(e.val(T),e.trigger("propertychange."+o))}else u()}),i.partialInputSupport&&t(n).on("selectionchange."+o,function(){r.getTextAreaLength()<i.lengthText&&e.trigger("propertychange."+o)})},dropFunction:function(){var t=r.dataStore;e.on("drop."+o,function(){r.dataStore.dropOccurred=!0,setTimeout(function(){r.trackSelectionFunction();var n,a=t.caretStatus,i=a.start,c=a.end;if(i!==c)t.caretStatus.start=i,t.caretStatus.end=i,n=c;else{var s=t.lengthText,u=e.val().length-s,l=i-u;t.caretStatus.start=l,t.caretStatus.end=l,n=i}r.setInputSelection(n,n),r.dataStore.dropOccurred=!1,e.trigger("input."+o)})})},pastePreventFunction:function(){e.on("paste."+o,function(t){r.negateEvent(t)})},deselectFunction:function(t){e.on("stopVerbosity-deselect",function(){var n=r.dataStore.limit,a=r.checkLimit(n);r.trackSelectionFunction(),"equal"===a?r.dataStore.indicator.useMaxlength&&t.preventFunction():"greater"===a&&e.trigger("propertychange."+o)})},selectFunction:function(t){e.on("select."+o,function(){if(!r.dataStore.dropOccurred){r.trackSelectionFunction();var e=r.dataStore.caretStatus,n=r.dataStore.limit,o=r.checkLimit(n),a=e.start,i=e.end,c=r.dataStore.selectCaretStatus;c.start=a,c.end=i,"equal"===o&&(e.end===e.start?r.dataStore.indicator.useMaxlength&&t.preventFunction():t.allowFunction())}})},trackSelectionEventsFunction:function(){var t=["mouseout","focus","blur","keyup"],n=r.appendNameSpace(t,o);e.on(n,function(){setTimeout(function(){r.trackSelectionFunction()})})},appendNameSpace:function(t,e){for(var n=t.length,o=0;n>o;o++)t[o]=t[o]+"."+e},mousedownFunction:function(){e.on("mousedown."+o,function(){r.setDataStore("isMouseDown",!0)})},clickFunction:function(){e.on("click."+o,function(){setTimeout(function(){r.trackSelectionFunction()}),r.setDataStore("isMouseDown",!1)})},keydownFunction:function(){var t=r.dataStore;this.keydownFunction.checkFirstKeyDown=function(n){t.checkFirstKeyDown&&t.continueKeyCheck&&setTimeout(function(){r.getTextAreaLength()>0&&e.trigger("propertychange."+o)}),"keyprevent"===n&&setTimeout(function(){e.trigger("propertychange."+o)})},this.keydownFunction.checkTab=function(t){return 9===t.which&&r.dataStore.isMouseDown?(r.negateEvent(t),!0):void 0},this.keydownFunction.keydownPrevent=function(){e.on("keydown."+o,function(e){switch(e.which){case 0:case 8:case 9:case 16:case 17:case 18:case 19:case 20:case 27:case 33:case 34:case 35:case 36:case 37:case 38:case 39:case 40:case 45:case 46:case 112:case 113:case 114:case 115:case 116:case 117:case 118:case 119:case 120:case 121:case 122:case 123:r.keydownFunction.checkTab(e),r.keydownFunction.checkFirstKeyDown("keyprevent"),t.falsePositive=!0;break;default:e.ctrlKey===!1&&e.preventDefault()}setTimeout(function(){r.trackSelectionFunction(),r.dataStore.selectBeforeKeydown=r.dataStore.isTextSelected?!0:!1})})},e.off("keydown."+o),this.keydownFunction.keydown=function(){e.on("keydown."+o,function(t){r.keydownFunction.checkTab(t),r.keydownFunction.checkFirstKeyDown(),setTimeout(function(){r.trackSelectionFunction(),r.dataStore.selectBeforeKeydown=r.dataStore.isTextSelected?!0:!1})})},this.keydownFunction.keydown()},dataStore:{newCaretPos:null,caretStatus:{start:0,end:0},selectCaretStatus:{start:0,end:0},dropOccurred:!1,isMouseDown:!1,isTextSelected:!1,isLimitReached:!1,textStatus:null,lengthText:0,keyDownPresent:!1,click:!1,eventPresent:"keydown",eventPrevent:null,falsePositive:!1,checkFirstKeyDown:!1,continueKeyCheck:!0,selectBeforeKeydown:!1,supportsInput:null},removeDataStore:function(t){this.dataStore[t]=null},setDataStore:function(t,e){this.dataStore[t]=e},copyObjectValue:function(t,e,n){for(var o in t)t.hasOwnProperty(o)&&n===o&&(e[n]=t[n])},negateEvent:function(t){t.preventDefault(),t.stopPropagation()},isTextSelected:function(t){return Math.abs(t.start-t.end)>0?!0:void 0},setSelectionStatus:function(){var t=this.dataStore;t.caretStatus=r.getInputSelection(),r.isTextSelected(t.caretStatus)?this.setDataStore("isTextSelected",!0):this.setDataStore("isTextSelected",!1)},trackSelectionFunction:function(){var t=r.dataStore.isTextSelected;r.setSelectionStatus();var n=r.dataStore.isTextSelected;t&&n===!1&&e.trigger("stopVerbosity-deselect")},getText:function(){return e.val()},getTextAreaLength:function(){return this.getText().replace(/\r(?!\n)|\n(?!\r)/g,"\r\n").length},checkLimit:function(t){var e=this.getTextAreaLength();return e>t?"greater":e===t?"equal":t>e?"less":void 0},setInputSelection:function(t,n){var o=this.setInputSelection,a=e[0];if("number"==typeof a.selectionStart&&"number"==typeof a.selectionEnd)a.selectionStart=t,a.selectionEnd=n;else{var r=a.createTextRange(),i=o.offsetToRangeCharacterMove(a,t);r.collapse(!0),t===n?r.move("character",i):(r.moveEnd("character",o.offsetToRangeCharacterMove(a,n)),r.moveStart("character",i)),r.select()}},getInputSelection:function(){var t,o,a,r,i,c=0,s=0,u=e[0];return"number"==typeof u.selectionStart&&"number"==typeof u.selectionEnd?(c=u.selectionStart,s=u.selectionEnd):(o=n.selection.createRange(),o&&o.parentElement()===u&&(r=u.value.length,t=u.value.replace(/\r\n/g,"\n"),a=u.createTextRange(),a.moveToBookmark(o.getBookmark()),i=u.createTextRange(),i.collapse(!1),a.compareEndPoints("StartToEnd",i)>-1?c=s=r:(c=-a.moveStart("character",-r),c+=t.slice(0,c).split("\n").length-1,a.compareEndPoints("EndToEnd",i)>-1?s=r:(s=-a.moveEnd("character",-r),s+=t.slice(0,s).split("\n").length-1)))),{start:c,end:s}}};return a.prototype}};i(e,a),i.prototype.init()};t.fn[o]=function(e){return this.each(function(){t.data(this,"plugin_"+o)||t.data(this,"plugin_"+o,new a(this,e))})}}(jQuery,window,document);